diff --git a/sysdeps/powerpc/fpu/round_to_integer.h b/sysdeps/powerpc/fpu/round_to_integer.h
index ba2d355fb0..5d4378063a 100644
--- a/sysdeps/powerpc/fpu/round_to_integer.h
+++ b/sysdeps/powerpc/fpu/round_to_integer.h
@@ -33,16 +33,23 @@ enum round_mode
 static inline void
 set_fenv_mode (enum round_mode mode)
 {
-  int rmode;
   switch (mode)
   {
-  case CEIL:  rmode = FE_UPWARD; break;
-  case FLOOR: rmode = FE_DOWNWARD; break;
+  case CEIL:
+    __fesetround_inline_nocheck (FE_UPWARD);
+    break;
+  case FLOOR:
+    __fesetround_inline_nocheck (FE_DOWNWARD);
+    break;
   case TRUNC:
-  case ROUND: rmode = FE_TOWARDZERO; break;
-  default:    rmode = FE_TONEAREST; break;
+  case ROUND:
+    __fesetround_inline_nocheck (FE_TOWARDZERO);
+    break;
+  case NEARBYINT:
+    /*  Disable FE_INEXACT exception  */
+    reset_fpscr_bit (FPSCR_XE);
+    break;
   }
-  __fesetround_inline_nocheck (rmode);
 }
 
 static inline float
diff --git a/sysdeps/powerpc/fpu/s_nearbyint.c b/sysdeps/powerpc/fpu/s_nearbyint.c
new file mode 100644
index 0000000000..48bcd86f04
--- /dev/null
+++ b/sysdeps/powerpc/fpu/s_nearbyint.c
@@ -0,0 +1,30 @@
+/* Largest integral value not greater than argument.  PowerPC version.
+   Copyright (C) 2019 Free Software Foundation, Inc.
+   This file is part of the GNU C Library
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Library General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Library General Public License for more details.
+
+   You should have received a copy of the GNU Library General Public
+   License along with the GNU C Library; see the file COPYING.LIB.  If
+   not, see <http://www.gnu.org/licenses/>.  */
+
+#define NO_MATH_REDIRECT
+#include <math.h>
+#include <fenv_private.h>
+#include <libm-alias-double.h>
+#include <round_to_integer.h>
+
+double
+__nearbyint (double x)
+{
+  return round_to_integer_double (NEARBYINT, x);
+}
+libm_alias_double (__nearbyint, nearbyint)
diff --git a/sysdeps/powerpc/fpu/s_nearbyintf.c b/sysdeps/powerpc/fpu/s_nearbyintf.c
new file mode 100644
index 0000000000..db8a3cdac7
--- /dev/null
+++ b/sysdeps/powerpc/fpu/s_nearbyintf.c
@@ -0,0 +1,30 @@
+/* Smallest integral value not less than argument.  PowerPC version.
+   Copyright (C) 2019 Free Software Foundation, Inc.
+   This file is part of the GNU C Library
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Library General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Library General Public License for more details.
+
+   You should have received a copy of the GNU Library General Public
+   License along with the GNU C Library; see the file COPYING.LIB.  If
+   not, see <http://www.gnu.org/licenses/>.  */
+
+#define NO_MATH_REDIRECT
+#include <math.h>
+#include <fenv_private.h>
+#include <libm-alias-float.h>
+#include <round_to_integer.h>
+
+float
+__nearbyintf (float x)
+{
+  return round_to_integer_float (NEARBYINT, x);
+}
+libm_alias_float (__nearbyint, nearbyint)
diff --git a/sysdeps/powerpc/powerpc32/fpu/s_nearbyint.S b/sysdeps/powerpc/powerpc32/fpu/s_nearbyint.S
deleted file mode 100644
index 4ed5d702f1..0000000000
--- a/sysdeps/powerpc/powerpc32/fpu/s_nearbyint.S
+++ /dev/null
@@ -1,80 +0,0 @@
-/* Round to int floating-point values.  PowerPC32 version.
-   Copyright (C) 2011-2019 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Contributed by Adhemerval Zanella <azanella@br.ibm.com>, 2011
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-/* This has been coded in assembler because GCC makes such a mess of it
-   when it's coded in C.  */
-
-#include <sysdep.h>
-#include <math_ldbl_opt.h>
-#include <libm-alias-double.h>
-
-
-/* double [fp1] nearbyint(double [fp1] x) */
-
-	.section	.rodata.cst4,"aM",@progbits,4
-	.align	2
-.LC0:	/* 2**52 */
-	.long 0x59800000	/* TWO52: 2**52 */
-
-	.section	".text"
-ENTRY (__nearbyint)
-#ifdef SHARED
-	mflr	r11
-	cfi_register(lr,r11)
-	bcl	20,31,1f
-1:	mflr	r9
-	addis	r9,r9,.LC0-1b@ha
-	lfs	fp13,.LC0-1b@l(r9)
-	mtlr	r11
-	cfi_same_value (lr)
-#else
-	lis	r9,.LC0@ha
-	lfs	fp13,.LC0@l(r9)
-#endif
-	fabs	fp0,fp1
-	fsub    fp12,fp13,fp13	/* generate 0.0  */
-	fcmpu	cr7,fp0,fp13	/* if (fabs(x) > TWO52 */
-	bge	cr7,.L10
-	fcmpu	cr7,fp1,fp12	/* if (x > 0.0 */
-	ble	cr7,L(lessthanzero)
-	mffs	fp11
-	mtfsb0	4*cr7+lt	/* Disable FE_INEXACT exception */
-	fadd	fp1,fp1,fp13	/* x += TWO52 */
-	fsub	fp1,fp1,fp13	/* x -= TWO52 */
-	fabs	fp1,fp1		/* if (x == 0.0 */
-	mtfsf	0xff,fp11	/* Restore FE_INEXACT state.  */
-	blr
-L(lessthanzero):
-	bgelr	cr7
-	mffs	fp11
-	mtfsb0	4*cr7+lt	/* Disable FE_INEXACT exception */
-	fsub	fp1,fp1,fp13	/* x -= TWO52 */
-	fadd	fp1,fp1,fp13	/* x += TWO52 */
-	fnabs	fp1,fp1		/* if (x == 0.0) */
-	mtfsf	0xff,fp11	/* Restore FE_INEXACT state.  */
-	blr
-.L10:
-	/* Ensure sNaN input is converted to qNaN.  */
-	fcmpu	cr7,fp1,fp1
-	beqlr	cr7
-	fadd	fp1,fp1,fp1
-	blr
-END (__nearbyint)
-
-libm_alias_double (__nearbyint, nearbyint)
diff --git a/sysdeps/powerpc/powerpc32/fpu/s_nearbyintf.S b/sysdeps/powerpc/powerpc32/fpu/s_nearbyintf.S
deleted file mode 100644
index b1895f9d10..0000000000
--- a/sysdeps/powerpc/powerpc32/fpu/s_nearbyintf.S
+++ /dev/null
@@ -1,79 +0,0 @@
-/* Round to int floating-point values.  PowerPC32 version.
-   Copyright (C) 2011-2019 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Contributed by Adhemerval Zanella <azanella@br.ibm.com>, 2011
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-/* This has been coded in assembler because GCC makes such a mess of it
-   when it's coded in C.  */
-
-#include <sysdep.h>
-#include <libm-alias-float.h>
-
-
-/* float [fp1] nearbyintf(float [fp1] x) */
-
-	.section	.rodata.cst4,"aM",@progbits,4
-	.align	2
-.LC0:
-	.long 0x4B000000	/* TWO23: 2**23 */
-
-	.section	".text"
-ENTRY (__nearbyintf)
-#ifdef SHARED
-	mflr	r11
-	cfi_register(lr,r11)
-	bcl	20,31,1f
-1:	mflr	r9
-	addis	r9,r9,.LC0-1b@ha
-	lfs	fp13,.LC0-1b@l(r9)
-	mtlr	r11
-	cfi_same_value (lr)
-#else
-	lis	r9,.LC0@ha
-	lfs	fp13,.LC0@l(r9)
-#endif
-	fabs	fp0,fp1
-	fsub    fp12,fp13,fp13		/* generate 0.0  */
-	fcmpu	cr7,fp0,fp13		/* if (fabs(x) > TWO23 */
-	bge	cr7,.L10
-	fcmpu	cr7,fp1,fp12		/* if (x > 0.0 */
-	ble	cr7,L(lessthanzero)
-	mffs	fp11
-	mtfsb0	4*cr7+lt		/* Disable FE_INEXACT exception */
-	fadds	fp1,fp1,fp13		/* x += TWO23 */
-	fsubs	fp1,fp1,fp13		/* x -= TWO23 */
-	fabs	fp1,fp1			/* if (x == 0.0) */
-	mtfsf	0xff,fp11		/* Restore FE_INEXACT state.  */
-	blr
-L(lessthanzero):
-	bgelr	cr7
-	mffs	fp11
-	mtfsb0	4*cr7+lt		/* Disable FE_INEXACT exception */
-	fsubs	fp1,fp1,fp13		/* x -= TWO23 */
-	fadds	fp1,fp1,fp13		/* x += TWO23 */
-	fnabs	fp1,fp1			/* if (x == 0.0) */
-	mtfsf	0xff,fp11		/* Restore FE_INEXACT state.  */
-	blr
-.L10:
-	/* Ensure sNaN input is converted to qNaN.  */
-	fcmpu	cr7,fp1,fp1
-	beqlr	cr7
-	fadds	fp1,fp1,fp1
-	blr
-END (__nearbyintf)
-
-libm_alias_float (__nearbyint, nearbyint)
diff --git a/sysdeps/powerpc/powerpc64/fpu/s_nearbyint.S b/sysdeps/powerpc/powerpc64/fpu/s_nearbyint.S
deleted file mode 100644
index 4065af8fe3..0000000000
--- a/sysdeps/powerpc/powerpc64/fpu/s_nearbyint.S
+++ /dev/null
@@ -1,68 +0,0 @@
-/* Round to int floating-point values.  PowerPC64 version.
-   Copyright (C) 2011-2019 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Contributed by Adhemerval Zanella <azanella@br.ibm.com>, 2011
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-/* This has been coded in assembler because GCC makes such a mess of it
-   when it's coded in C.  */
-
-#include <sysdep.h>
-#include <math_ldbl_opt.h>
-#include <libm-alias-double.h>
-
-
-/* double [fp1] nearbyint(double [fp1] x) */
-
-	.section	".toc","aw"
-.LC0:	/* 2**52 */
-	.tc FD_43300000_0[TC],0x4330000000000000
-	.section	".text"
-
-ENTRY (__nearbyint, 4)
-	CALL_MCOUNT 0
-	fabs	fp0,fp1
-	lfd	fp13,.LC0@toc(2)
-	fcmpu	cr7,fp0,fp13	/* if (fabs(x) > TWO52)  */
-	bge	cr7,.L10
-	fsub	fp12,fp13,fp13	/* generate 0.0 */
-	fcmpu	cr7,fp1,fp12	/* if (x > 0.0) */
-	ble	cr7, L(lessthanzero)
-	mffs	fp11
-	mtfsb0	4*cr7+lt	/* Disable FE_INEXACT exception */
-	fadd	fp1,fp1,fp13	/* x+= TWO52 */
-	fsub	fp1,fp1,fp13	/* x-= TWO52 */
-	fabs	fp1,fp1		/* if (x == 0.0) */
-	mtfsf	0xff,fp11	/* Restore FE_INEXACT state.  */
-	blr			/* x = 0.0; */
-L(lessthanzero):
-	bgelr	cr7		/* if (x < 0.0) */
-	mffs	fp11
-	mtfsb0	4*cr7+lt
-	fsub	fp1,fp1,fp13	/* x -= TWO52 */
-	fadd	fp1,fp1,fp13	/* x += TWO52 */
-	fnabs	fp1,fp1		/* if (x == 0.0) */
-	mtfsf	0xff,fp11	/* Restore FE_INEXACT state.  */
-	blr			/* x = -0.0; */
-.L10:
-	/* Ensure sNaN input is converted to qNaN.  */
-	fcmpu	cr7,fp1,fp1
-	beqlr	cr7
-	fadd	fp1,fp1,fp1
-	blr
-END (__nearbyint)
-
-libm_alias_double (__nearbyint, nearbyint)
diff --git a/sysdeps/powerpc/powerpc64/fpu/s_nearbyintf.S b/sysdeps/powerpc/powerpc64/fpu/s_nearbyintf.S
deleted file mode 100644
index 69949028a3..0000000000
--- a/sysdeps/powerpc/powerpc64/fpu/s_nearbyintf.S
+++ /dev/null
@@ -1,69 +0,0 @@
-/* Round to int floating-point values.  PowerPC64 version.
-   Copyright (C) 2011-2019 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Contributed by Adhemerval Zanella <azanella@br.ibm.com>, 2011
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-/* This has been coded in assembler because GCC makes such a mess of it
-   when it's coded in C.  */
-
-#include <sysdep.h>
-#include <libm-alias-float.h>
-
-
-/* float [fp1] nearbyintf(float [fp1]) */
-
-	.section	".toc","aw"
-	.p2align 3
-.LC0:	/* 2**23 */
-	.long 0x4b000000
-	.long 0x0
-	.section	".text"
-
-ENTRY (__nearbyintf, 4)
-	CALL_MCOUNT 0
-	fabs	fp0,fp1
-	lfs	fp13,.LC0@toc(2)
-	fcmpu	cr7,fp0,fp13	/* if (fabs(x) > TWO52)  */
-	bge	cr7,.L10
-	fsubs	fp12,fp13,fp13	/* generate 0.0 */
-	fcmpu	cr7,fp1,fp12	/* if (x > 0.0)  */
-	ble	cr7, L(lessthanzero)
-	mffs	fp11
-	mtfsb0	4*cr7+lt	/* Disable FE_INEXACT exception */
-	fadds	fp1,fp1,fp13	/* x += TWO23 */
-	fsubs	fp1,fp1,fp13	/* x -= TWO23 */
-	fabs	fp1,fp1		/* if (x == 0.0) */
-	mtfsf	0xff,fp11	/* Restore FE_INEXACT state.  */
-	blr			/* x = 0.0; */
-L(lessthanzero):
-	bgelr	cr7		/* if (x < 0.0) */
-	mffs	fp11
-	mtfsb0	4*cr7+lt	/* Disable FE_INEXACT exception */
-	fsubs	fp1,fp1,fp13	/* x -= TWO23 */
-	fadds	fp1,fp1,fp13	/* x += TWO23 */
-	fnabs	fp1,fp1		/* if (x == 0.0) */
-	mtfsf	0xff,fp11	/* Restore FE_INEXACT state.  */
-	blr			/* x = -0.0; */
-.L10:
-	/* Ensure sNaN input is converted to qNaN.  */
-	fcmpu	cr7,fp1,fp1
-	beqlr	cr7
-	fadds	fp1,fp1,fp1
-	blr
-END (__nearbyintf)
-
-libm_alias_float (__nearbyint, nearbyint)